UNIT mTKugel;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTSpielfeld, mSuM;

type
  TKugel = class

  private //Attribute
    meinStift : Stift;
    kenntSpielfeld : TSpielfeld;
    AktuelleXGeschwindigkeit : Zahl;
    AktuelleYGeschwindigkeit : Zahl;
    AktuelleXPos : Zahl;
    AktuelleYPos : Zahl;

     //Objektbeziehungen:
        // kenntTSpielfeld : TSpielfeld;
        // kenntTKugel () of TKugel;
        // kenntTSpielfeld ((1.1)  wie lautet die X-Koordinate deines rechten Randes) of TSpielfeld;
        // kenntTKugel () of TKugel;
        // kenntTKugel () of TKugel;

  public //Methoden
    constructor init; virtual;
    procedure bewege; virtual;
    procedure lerneSpielfeldKennen (pKenntSpielfeld: TSpielfeld); virtual;
    procedure SetzeGeschwindigkeit (pAktuelleXGeschwindigkeit: Zahl; pAktuelleYGeschwindigkeit: Zahl); virtual;
    procedure setzePosition (pXPos: Zahl; pYPos: Zahl); virtual;
    destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKugel.init;
begin
  meinStift := Stift.init;
  AktuelleXPos := 0;
  AktuelleYPos := 0;
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
begin
     //Kugel an alter Stelle lschen
     meinStift.radiere;
     meinStift.bewegeBis(AktuelleXPos,AktuelleYPos);
     meinStift.zeichneKreis(10);

     //Kugel an neue Stelle bewegen
     AktuelleXPos := AktuelleXPos + AktuelleXGeschwindigkeit;
     AktuelleYPos := AktuelleYPos + AktuelleYGeschwindigkeit;

     //Kugel neu zeichnen
     meinStift.normal;
     meinStift.bewegeBis(AktuelleXPos,AktuelleYPos);
     meinStift.zeichneKreis(10);

    if self.AktuelleXPos + 12 > kenntSpielfeld.rechterRand then
       AktuelleXGeschwindigkeit := -AktuelleXGeschwindigkeit;
    if self.AktuelleXPos - 12 < kenntSpielfeld.linkerRand then
       AktuelleXGeschwindigkeit := -AktuelleXGeschwindigkeit;
    if self.AktuelleYPos + 12 > kenntSpielfeld.untererRand then
       AktuelleYGeschwindigkeit := -AktuelleYGeschwindigkeit;
    if self.AktuelleYPos - 12 < kenntSpielfeld.obererRand then
       AktuelleYGeschwindigkeit := -AktuelleYGeschwindigkeit;

end;

//-------- lerneSpielfeldKennen (public) -------------------------------
procedure TKugel.lerneSpielfeldKennen (pKenntSpielfeld: TSpielfeld);
begin
  kenntSpielfeld := pKenntSpielfeld
end;

//-------- SetzeGeschwindigkeit (public) -------------------------------
procedure TKugel.SetzeGeschwindigkeit (pAktuelleXGeschwindigkeit: Zahl; pAktuelleYGeschwindigkeit: Zahl);
begin
   AktuelleXGeschwindigkeit := pAktuelleXGeschwindigkeit;
   AktuelleYGeschwindigkeit := pAktuelleYGeschwindigkeit
end;

//-------- setzePosition (public) --------------------------------------
procedure TKugel.setzePosition (pXPos: Zahl; pYPos: Zahl);
begin
   //Kugel an alter Stelle lschen
   meinStift.radiere;
   meinStift.bewegeBis(AktuelleXPos,AktuelleYPos);
   meinStift.zeichneKreis(10);

   //Gedchtnis benutzen !!  : Position merken
   AktuelleXPos := pXPos;
   AktuelleYPos := pYPos;

   //neu Zeichnen an neuer Position
   meinStift.normal;
   meinStift.bewegeBis(AktuelleXPos,AktuelleYPos);
   meinStift.zeichneKreis(10);
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  meinStift.gibFrei;
end;

end.
